package tk.to_p.blankedoutbox.garlicclone.core;
import java.util.Vector;

/**
 * Game settings
 */
public class PlayerSetting {
	/** Playfield width */
	public int PlayfieldWidth = 10;

	/** Playfield height (Visible height * 2) */
	public int PlayfieldHeight = 40;

	/** Visible playfield height. This is only for the renderer codes; not used by Garlic engine itself. */
	public int VisiblePlayfieldHeight = 20;

	/** Another visible playfield height (?) This is only for the renderer codes; not used by Garlic engine itself. */
	public int VisiblePieceHeight = 20;

	/** DAS (Delayed Auto Shift) */
	public int MoveDelay = 130;

	/** ARR (Auto Repeat Rate) */
	public int MoveInterval = 15;

	/** Initial delay for piece rotation. It works just like Te*ris Worlds. */
	public int RotateDelay = 0;

	/** Auto-repeat rate for piece rotation. It works just like Te*ris Worlds. */
	public int RotateInterval = 0;

	/** Initial delay for Soft Drop */
	public int SoftDropDelay = 10;

	/** Auto-repeat rate for Soft Drop */
	public int SoftDropInterval = 10;

	/** Initial delay for Hard Drop */
	public int HardDropDelay = 0;

	/** Auto-repeat rate for Hard Drop */
	public int HardDropInterval = 0;

	/** Hold ARE. It's a very strange feature. Why there are no standard ARE setting? */
	public int HoldDelay = 0;

	/** true to enable Hard Drop */
	public boolean EnableHardDrop = true;

	/** Movement/Rotation limit after the piece touches to floor */
	public int ExtendedPlacementCount = 15;

	/** Lock delay */
	public int LockDownDelay = 500;

	/** Piece spawn position (X) */
	public int PieceStartPosX = 3;

	/** Piece spawn position (Y) */
	public int PieceStartPosY = 18;

	/** It controls how fast the stack falls after the blocks disappear */
	public int MinoGravity = 50;

	/** Line clear delay */
	public int LineLifeTime = 0;

	/** Piece previews. This is only for the renderer codes. */
	public int NextBlockCount = 6;

	/** Piece bag size. Change this value to 8 to play with a 8-piece bag (All 7 pieces + 1 random) */
	public int BagSize = 7;

	/** It controls what pieces will be in the bag */
	public Vector<Integer> BagElements = null;

	/** Delay before the auto-fall timer begins (Not unlike PS2 Te*ris Kiwamemichi) */
	public int FollowDownDelay = 0;

	/** Number of Holds (-1:Unlimited) This is from dark Gungho era of TOJ. */
	public int HoldBlockCount = -1;

	/** true to render ghost piece. This is only for the renderer codes. */
	public boolean DrawGhost = true;

	/** It will show where an AI will put the piece. Not implemented in Flash games. */
	public boolean DrawBest = false;

	/** It displays "DO HOLD" when AI thinks you should use Hold now. Not implemented in Flash games. */
	public boolean DrawHoldRecommended = false;

	/** Miss-drop enabled flag. It's not directly used by Garlic-engine, but there are some codes in Flash games. */
	public boolean MissDropCheck = false;

	/** Max-wallkick level. 0 to disable wallkicks, 5 to enable all. */
	public int RotationLevel = 5;

	/** Enable T-Spin flag */
	public boolean tSpinRule = true;

	/** Enable Combo (REN) flag */
	public boolean ComboRule = true;

	/** Enable "Cheap Spins" (T-Spin Mini) flag */
	public boolean CheapSpinRule = true;

	/** Attack points for T-Spin Triple */
	public int AttackTSpin3 = 60;

	/** Attack points for T-Spin Dobule */
	public int AttackTSpin2 = 40;

	/** Attack points for T-Spin Single */
	public int AttackTSpin1 = 20;

	/** Attack points for T-Spin Single Mini */
	public int AttackTSpin1Mini = 10;

	/** Attack points for T-Spin Zero */
	public int AttackTSpin0 = 0;

	/** Attack points for Te*ris */
	public int AttackTetris = 40;

	/** Attack points for Triple */
	public int AttackTriple = 20;

	/** Attack points for Double */
	public int AttackDouble = 10;

	/** Attack points for Single */
	public int AttackSingle = 0;

	/** Attack points for B2B T-Spin Triple */
	public int AttackB2BTSpin3 = 80;

	/** Attack points for B2B T-Spin Double */
	public int AttackB2BTSpin2 = 50;

	/** Attack points for B2B T-Spin Single */
	public int AttackB2BTSpin1 = 30;

	/** Attack points for B2B T-Spin Single Mini */
	public int AttackB2BTSpin1Mini = 20;

	/** Attack points for B2B Te*ris */
	public int AttackB2BTetris = 50;

	/** Attack points for Combo (REN) */
	public int[] AttackCombos = {0, 10, 10, 20, 20, 30, 30, 40, 40, 40, 50, 50, 50, 50, 50, 50, 50, 50, 50, 50};

	/** Minimum combo value for attacks */
	public int AttackComboStartCount = 2;

	/** Attack points for Perfect Clear */
	public int AttackPerfectClear = 60;	// Flash:2

	/** Points for T-Spin Triple */
	public int ScoreTSpin3 = 1200;	// Flash:1800

	/** Points for T-Spin Double */
	public int ScoreTSpin2 = 800;	// Flash:1200

	/** Points for T-Spin Single */
	public int ScoreTSpin1 = 500;	// Flash:800

	/** Points for T-Spin Single Mini */
	public int ScoreTSpin1Mini = 300;	// Flash:0 (WTF!?)

	/** Points for T-Spin Zero */
	public int ScoreTSpin0 = 100;	// Flash:400

	/** Points for Te*ris */
	public int ScoreTetris = 800;

	/** Points for Triple */
	public int ScoreTriple = 500;

	/** Points for Double */
	public int ScoreDouble = 300;

	/** Points for Single */
	public int ScoreSingle = 100;

	/** Points for B2B T-Spin Triple */
	public int ScoreB2BTSpin3 = 1800;	// Flash:2700

	/** Points for B2B T-Spin Double */
	public int ScoreB2BTSpin2 = 1200;	// Flash:1800

	/** Points for B2B T-Spin Single */
	public int ScoreB2BTSpin1 = 750;	// Flash:1200

	/** Points for B2B T-Spin Single Mini */
	public int ScoreB2BTSpin1Mini = 450;	// Flash:0 (WTF!?)

	/** Points for B2B Te*ris */
	public int ScoreB2BTetris = 1200;

	/** Minimum value of combo bonus */
	public int ScoreComboStartCount = 2;

	/** Points for each combo */
	public int ScoreComboSize = 50;

	/** Combo points interval (If you set it 2 and ScoreComboSize is 50, the combo points will be 50, 50, 100, 100, 200, 200, ...) */
	public int ScoreComboInterval = 1;

	/** Points for Perfect Clear */
	public int ScorePerfectClear = 1800;	// Flash:0

	/**
	 * [Added] Constructor
	 */
	public PlayerSetting() {
		BagElements = new Vector<Integer>();
		BagElements.addElement(GarlicConst.TetriminoType_O);
		BagElements.addElement(GarlicConst.TetriminoType_I);
		BagElements.addElement(GarlicConst.TetriminoType_T);
		BagElements.addElement(GarlicConst.TetriminoType_L);
		BagElements.addElement(GarlicConst.TetriminoType_J);
		BagElements.addElement(GarlicConst.TetriminoType_S);
		BagElements.addElement(GarlicConst.TetriminoType_Z);
	}

	/**
	 * Get the piece fall speed (gravity)
	 * @param level Level
	 * @return Piece fall speed (gravity)
	 */
	public int GetPieceFallSpeed(int level) {
		// This code is from Flash games (AS2.0)
		// It's very similar to Te*ris Worlds and Zone.
		double v1 = Math.pow(0.8 - (level - 1) * 0.007, level - 1);
		long v2 = Math.round(v1 * 1000 + 0.5);
		return (int)Math.max(1L, v2);

		// This code is from replayer (AS3.0)
		// Probably it's faster than the above one because it doesn't use floats and doubles.
		/*
		int[] speedTable = {2000, 1000, 793, 618, 473, 355, 262, 190, 135, 94, 64, 43, 28, 18, 11, 7, 4, 3};
		if(level >= speedTable.length) return 1;
		return speedTable[level];
		*/
	}
}
