package tk.to_p.blankedoutbox.garlicclone.core;
import java.util.Random;

/**
 * Random Number Generator
 */
public class RandomStream {
	/** The actual RNG (from Java) */
	protected Random rand;

	/**
	 * Constructor
	 */
	public RandomStream() {
		rand = new Random();
	}

	/**
	 * Set Random-Seed
	 * @param seed Seed
	 */
	public void SetSeed(long seed) {
		rand = new Random(seed);
	}

	/**
	 * Generate a random number
	 * @param iMinVal Minimum number (inclusive)
	 * @param iMaxVal Maximum number (It seems also inclusive)
	 * @return Random number
	 */
	public int RandomInt(int iMinVal, int iMaxVal) {
		return rand.nextInt(iMaxVal-iMinVal)+iMinVal;
	}
}
